#ifndef UTILITIEC_SUBPROCESS_H
#define UTILITIEC_SUBPROCESS_H

#include "../StringView/StringView.h"
#include <sys/types.h>

// TODO: Implement FILE redirection
enum SubprocessRedirectionType {
	SUBPROCESSREDIRECTIONTYPE_PIPE,
	SUBPROCESSREDIRECTIONTYPE_FILE,
};

union SubprocessRedirectionContent {
	int pipefd;
	StringView file_name;
};

typedef struct SubprocessRedirection_s {
	enum  SubprocessRedirectionType type;
	union SubprocessRedirectionContent get;
} SubprocessRedirection;

typedef struct Subprocess_t {
	pid_t child_pid;
	SubprocessRedirection in;
	SubprocessRedirection out;
	SubprocessRedirection err;
} Subprocess;


#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__))


int Subprocess_Create(Subprocess* subprocess, char* file, char** argv);
void Subprocess_Destroy(Subprocess* subprocess);


#else
// TODO: Implement for Windows with a windows testing machine
#error "This module is not implemented for your platform yet"
#endif // platform

#endif // header
